// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
// -*-C++-*-
//
// File:      omsource.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Fri Aug  9 17:05:36 MEST 2002
#include "flagchecker.h"
#include <iostream>
#include "Dal.h"
#include <sstream>
#include<fstream>
#include <iomanip>
#include "sourcelist.h"
#include "OmImage.h"
#include "allocate.h"
#include "mode.h"
void ConvertCoords(float &xCoord, float& yCoord, int x0, int y0, int xBin, int yBin);
void checkImage(const string &, int size, const float* xpos, const float* ypos, const float *ignificance, const float *semia); 


bool badPixels(float **image, int nx, int ny, 
               const float x, const float y,
               int &i0, int &i0, float& maxPixel);



void checkImageStatistics( float **image, int nx, int ny, string filter, float exposure);



void flagchecker()
{
  


    string fileName = stringParameter( "set");
   

    // Open the file
    DataSet *dataSet = dataSetServer->open(fileName, Dal::Read);




    string filter = dataSet->attribute( "FILTER" )->asString();   

    if ( (filter.find("GRI", 0) != string::npos) || (filter.find("Gri", 0) != string::npos) ||  (filter.find("gri", 0) != string::npos))
    {

       ofstream output("grism.dat", ios::app);
       char buffer[100];
       sprintf(buffer, "%40s%10s", fileName.c_str(), filter.c_str());
       output << buffer <<  endl;



       output.close();

       dataSetServer->close(dataSet); // Finished with the file


       exit(0);;

    }

   






    /**********************************************************************
    *  Load all the source data
    *
    **********************************************************************/
    vector < OmSourceParameter > source;
    int size = 0;
    if (!loadSourceParameters(fileName, "SRCLIST", size, source, filter) )

    { 

      cout << "Error loading data fro file " << fileName << endl;
      exit(0);    
                 
    }
  
    for( int i = 0; i < size; i++)
    {
      if ( source[i].qualityflag & ( 1 << 3))
      {
	cout << (i+1) << ") x=" << source[i].xcoord << " y=" << source[i].ycoord << " quality flag=" << source[i].qualityflag << endl;
        cout << "File name=" << fileName << endl;
       
        Sas::fatal("Quality flag set", fileName);
   

   


      }

    }   



};
