// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#ifndef GRAPH_H
#define GRAPH_H
#include<vector>
#include<string>


struct BinData
{ 
  float dx;
  float xMin;
  float xMax;
  string label1, label2, label3;
}; 


void action1(vector<float> &x, vector<float> &y, void * data);




/**********************************************************
*
*
**********************************************************/
template<class kind>
kind minval( kind *data, int n)
{

    kind min1 = data[0];
    for (int i = 1; i < n; i++)
      min1 = min( min1, data[i] );

    return min1;



}


/**********************************************************
*
*
**********************************************************/

template<class kind>
kind maxval( kind *data, int n)
{

    kind max1 = data[0];
    for (int i = 1; i < n; i++)
      max1 = max( max1, data[i] );

    return max1;



}




void drawGraph( int ndata, 
                float* xdata, 
                float *xerrors, 
                float *ydata, 
                float *yerrors,
                char *title, 
                char *xlabel, 
                char *ylabel, 
                float x1, 
                float x2, 
                float y1, 
                float y2, 
                float xmin1 = -1.0, 
                float xmax1 = -1.0, 
                float ymin1 = -1.0, 
                float ymax1 = -1.0, 
                bool equalAxes = false);
  



void drawGraph( 
                vector<float> &xdata, 
                vector<float> &xerrors, 
                vector<float> &ydata, 
                vector<float> &yerrors,
                vector<int> & colourIndex,
                char *title, 
                char *xlabel, 
                char *ylabel, 
                float x1, 
                float x2, 
                float y1, 
                float y2, 
                float xmin1 = -1.0, 
                float xmax1 = -1.0, 
                float ymin1 = -1.0, 
                float ymax1 = -1.0, 
                bool equalAxes = false);
  








void drawGraph( int ndata, 
                float* xdata,  
                float *ydata, 
                char *title, 
                char *xlabel, 
                char *ylabel, 
                float x1, 
                float x2, 
                float y1, 
                float y2, 
                float xmin1 = -1.0, 
                float xmax1 = -1.0, 
                float ymin1 = -1.0, 
                float ymax1 = -1.0, 
                bool equalAxes = false);
  



void drawGraph( 
                vector<float> &xdata,  
                vector<float> &ydata,  
              
                char *title, 
                char *xlabel, 
                char *ylabel, 
                float x1, 
                float x2, 
                float y1, 
                float y2, 
                float xmin1 = -1.0, 
                float xmax1 = -1.0, 
                float ymin1 = -1.0, 
                float ymax1 = -1.0, 
                bool equalAxes = false);
  








/****************************************************************
 *
 *
 *****************************************************************/
void drawGraph( int ngraphs, 
                vector< vector<float> > &xdata,
                vector< vector<float> > &ydata,
                vector< string >  &subTitle,
                char *xlabel, 
                char *ylabel, 
                char *title,
                float x1, 
                float x2,  
                float xmin1, 
                float xmax1, 
                float ymin1, 
                float ymax1, 
                bool equalAxes,
                float dw = 0.25);
  




/****************************************************************
 *
 *
 *****************************************************************/
void drawGraph( int ngraphs, 
                vector< vector<float> > &xdata,
                vector< vector<float> > &ydata, 
                 char *xlabel, 
                char *ylabel, 
                char *title,
                vector<string> &subTitle, 
                float x1, 
                float x2,
                float y1,
                float y2,  
                float xmin1 = 0.0, 
                float xmax1 = 0.0, 
                float ymin1 = 0.0, 
                float ymax1 = 0.0);
  





/****************************************************************
 *
 *
 *****************************************************************/
void drawGraph( int ngraphs, 
                vector< vector<float> > &xdata,
                vector< vector<float> > &ydata,
                void (*Action)( vector<float> &x, vector<float> &y, void *data),
                vector<void *> &data,
                vector< string >  &subTitle,
                char *xlabel, 
                char *ylabel, 
                char *title,
                float x1, 
                float x2,  
                float xmin1, 
                float xmax1, 
                float ymin1, 
                float ymax1, 
                bool equalAxes,
                float dw = 0.25);
  



        

/****************************************************************
 *
 *
 *****************************************************************/
void drawGraph( int ngraphs, 
                vector< vector<float> > &xdata,
                vector< vector<float> > &ydata, 
                vector< vector<float> > &bin,             
                vector< vector<float> > &median, 
                vector< vector<float> > &lBound, 
                vector< vector<float> > &uBound, 
                vector<string> &subTitle, 
                char *xlabel, 
                char *ylabel, 
                char *title, 
                float x1, 
                float x2,  
                float xmin1, 
                float xmax1, 
                float ymin1, 
                float ymax1, 
                bool equalAxes,
                float dw1 = 0.25);


void Histogram( int ndata, float *data, float binWidth, 
                 char *xLabel, char *title, 
		float x1, float x2, float y1, float y2, float xmin, float xmax);


void Histogram( vector<float> &data, float binWidth, 
                 char *xLabel, char *title, 
		float x1, float x2, float y1, float y2, float xmin, float xmax);





void Histogram( vector<float>& data, float binWidth, 
                vector<string> &heading,  char *xLabel, char *title, 
		float x1, float x2, float y1, float y2, float xmin, float xmax);


void Histogram( vector<vector<float> >& data, float binWidth, 
                vector<string> & subTitle,  char *xLabel, char *title, 
		float x1, float x2, float y1, float y2, float xmin, float xmax);




/*****************************************************
 * Subroutine Histogram
 *
 ******************************************************/
void Histogram( vector< vector<float> >& data1, float binWidth, 
		vector<string> &subTitle, char *xlabel, 
                 char *title, 
                 float x1, float x2, 
		float xmin, float xmax, float dr = 0.2);
    
         

/***************************************************************
*
*
****************************************************************/
float Median(vector<float> &data);
/***************************************************************
*
*
****************************************************************/

float Mean(float *data, long nData);
float Mean(vector<float> &data);


/***************************************************************
*
*
****************************************************************/
float Median(float *data, long nData);    

float Percentile(vector<float> &data, float perCent);

float Percentile(float *data, long nData, float perCent);


/*********************************************************************
*
*
**********************************************************************/
void binnedData(vector<float>  &xData, 
                vector<float>  &yData,
                float xMin, 
                float xMax, 
                float dx,
                vector<float>  &bins,
                vector<float>  &median,
                vector<float>  &lower,
                vector<float>  &upper);





/*********************************************************************
*
*
**********************************************************************/

void drawMap( vector<float> &xdata  ,          
              vector<float> &ydata  ,      
              char *title, 
              char *xlabel, 
              char *ylabel, 
              float x1, 
              float x2,
              float y1, 
              float y2,             
              float xmin1, 
              float xmax1, 
              float ymin1, 
              float ymax1, 
	      bool equalAxes);
    

#endif


