// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#include<vector>
#include<iostream>
#include <cmath>
#include <algorithm>
#include<numeric>
#include<iomanip>
#include <cstring>

#include "mode.h"







/*********************************************************************************
*
***********************************************************************************/
extern "C" void halfrangemode_(int *nData,  float x[], float *mode, float *mean, float *median)
{


    vector<float> data;

    
    for (int i = 0; i < *nData; i++)
        data.push_back( x[i]);




    *mean = 0.0, *median = 0.0;
    *mode = halfRangeMode( data, *mean, *median );

  
  
  
    
 
}

/********************************************************
*
********************************************************/
float halfRangeMode(vector<float>& data, float &mean, float &median)
{

  
    vector<float> tempData1;
    sort(data.begin(), data.end());
  


     
    median = Median( data );

    
    mean   = Mean( data );

     
    float med1 = max((float)1.0, median);
    float high = med1 + 3.0 * sqrt(med1);

 

    for (long unsigned i = 0; i < data.size(); i++)
        if (data[i] >= 0.0 && data[i] <= high) tempData1.push_back(data[i]); 


    

    unsigned long minSize = 10;    



   





   
    
    unsigned size = tempData1.size();
    if (size < minSize) return Mean(data);
    


    long unsigned iStart = 0;  



   
    vector<float>tempData = maxInterval(tempData1, iStart, 0.1);
    


    for (int i = 1; i <= 10000; i++)
    {

      

      //      cout << "Half-rnage mode - iteration " << i << endl;   


        tempData = maxInterval(tempData1, iStart);

   
        unsigned long size = tempData.size();
	//	cout << "size of tempdata=" << size << endl; 	

	if (size <= minSize || size == tempData1.size())    
        {


	    float mode = Mean( tempData ); 	 
            

	    //            float std = 3.0 * max(0.5, (double)StandardDeviation( tempData ));
          
	    //            float xl = mean - std;
	    //            float xu = mean + std;

	    //            cout << "The final data\n";
	    //	    for (unsigned long i = 0; i < tempData.size(); i++)
	    //	      cout << i << ") data=" << tempData[i] << endl;	    

          
	    //            iStart += tempData.size();

	    //            for (unsigned long i = iStart; i < data.size(); i++)
	    //	        if ( data[i] <= xu) tempData.push_back(data[i]);

	    //	    mean = Mean( tempData );

	    //	    cout << "half-range mode- initila mean=" << mean << " size=" << size << " istart=" << iStart << " final mean=" << finalMean << endl;
	   
	    //            cout << "Returning mean " << mean << endl; 
            return mode;    

        }
        
        

    
        tempData1 = tempData;
   
	
 
    };
    cout << "Failed to finish!\n";
    cout << "size=" << size << endl;
    exit(0);
}
/****************************************************
*
*
****************************************************/
vector<float> maxInterval(vector<float> &data, long unsigned &iStart, float constant)
{

  
    vector< vector<float> > bin;
    long unsigned n = data.size(); 

    //    float mean = Mean(data);
    //    float median = Median(data);
    //    if ( median > mean ) return data;
    //    if ( mean < 0.5) return data;
    //    if ( (mean - median) / mean < 0.01) return data; 
    


    float width = data[n - 1] - data[0];

    if (width < 0.1) return data;

    float halfWidth = width * constant;


    float wMin = 10000000000.0;    

    long unsigned maxCount = 0;
    long unsigned noBins = 0; 

    vector< vector<long unsigned> > index;
   


    for(unsigned long i = 0; i < (n - 3); i++)
    {
    
   
        float f = data[i];
       
	float fPlus  = f + halfWidth;
	//	cout << "Maxinterval i=" << i << " f=" << f << " fplus=" << fPlus << endl;    
 
     
       
    
      
        long unsigned iu = i;
	
	iu = Locate( data, iu, fPlus);

        long unsigned count = iu - i + 1;



	//	count = 0;   
   
	//	        for(unsigned long j = i; j < n; j++)
	//	        {

	//		    if ( data[j] > fPlus) 
	//	            {

	//		        iu = j - 1;
	//	                break;            

	//		    }
	       
            
	//		    count++;
	  	            
            
	//	        } 
       
	 
	if (count == n)
	  return data;


    
	//       cout << "Line 674 i=" << i << " iu=" << iu << " count=" << count << " maxcount=" << maxCount << endl;   

    
        if (count > maxCount)
	{ 
	 

            wMin = data[iu] - data[i];

	    bin.clear();
            index.clear();
            bin.resize(1);
            index.resize(1);
	    //	    cout << "Line 699 count>maxcount" << count << " maxcount=" << maxCount << 
	    //	      " i=" << i << " iu=" << iu << endl;
           
            for(unsigned long j = i; j <= iu; j++)
	    {
 
                bin[0].push_back( data[j] );
                index[0].push_back(j);
            
            }
	    //            cout << "Line 654\n";
            noBins = 1;
	  
            maxCount = count;   
        }
        else if (count == maxCount)
	{
	  //	     cout << "Line 706 count=maxcount" << count << " maxcount=" << maxCount << endl;


	    float width = data[iu] - data[i];
            if (width < wMin)
	    {
	        wMin = width; 

	        bin.clear();
                index.clear();	
                bin.resize(1);
                index.resize(1);
		//                cout << "Line 720\n"; 
                
                for(unsigned long j = i; j <= iu; j++)
	        {
 
                    bin[0].push_back( data[j] );
                    index[0].push_back(j);
            
                }

 

                noBins = 1;

            }  
            else
	    {

                bin.resize(noBins + 1);
                index.resize(noBins + 1);

            
		//                cout << "Line 742\n";
                for(unsigned long j = i; j <= iu; j++)
	        {
 
                    bin[noBins].push_back(data[j]);
                    index[noBins].push_back(j);
            
                }


                noBins++;
	    }
      

          
        }
    } 


    //    cout << "Line 698 nobins=" << noBins << " binsize=" << bin.size() << endl; 
 

    if (noBins == 1)
    {     


 

        iStart += index[0][0];
    
        return bin[0];

    }




    vector< bool > used;
    used.resize(n);
    for(long unsigned i = 0; i < n; i++)
        used[i] = false;  

 

    /**********************************************************************
    *
    *
    **********************************************************************/
    
   
 

   
    wMin += 0.00001;

    //    cout << "Line 793 wmin=" << wMin << endl;

    vector<float> tempData;


    long unsigned minIndex = index[0][0];
    for (long unsigned i = 0; i < noBins; i++)
    {
    
           long unsigned n = bin[i].size();
   

        if ( (bin[i][n - 1] - bin[i][0]) <= wMin)
	{
       

      
	    for (long unsigned j = 0; j < n; j++)
	    {
	  

		if( !used[index[i][j]])
		{              
		
		
	      	    tempData.push_back( bin[i][j] );
                    used[index[i][j]] = true;
                    minIndex = min( minIndex, index[i][j] );                      
		} 


	    }
        }
 
    } 

   
 
    int size = tempData.size() - 1;


    //    cout << "Line 836 size=" << size << endl;


    if ( (tempData[1] - tempData[0]) < (tempData[size] - tempData[size - 1]) )
    {
        tempData.erase(tempData.begin() + size);
	size--;
    }
    else if ( (tempData[1] - tempData[0]) > (tempData[size] - tempData[size - 1]))
    {
        tempData.erase(tempData.begin());
        minIndex++;
        size--;
    }
    else if ( (tempData[1] - tempData[0]) == (tempData[size] - tempData[size - 1]))
    {
        tempData.erase(tempData.begin() + size);
        tempData.erase(tempData.begin());
        minIndex++;

        size -= 2;
    }


    iStart += minIndex; 
				   
         
    return tempData;


}
/*********************************************************************
*
*
*
*********************************************************************/


vector<float> resampledData(vector<float> &data)
{

    vector<float> tempData;
  
   
    long unsigned n = data.size();
    //    cout << "resampleddata n=" << n << endl;
    tempData.resize(n);




   
    for(long unsigned i = 0; i < n; i++)
    {
    

      long unsigned k  = (long unsigned)( (double)(n - 1) * (double)rand() / double(RAND_MAX - 1));




    
      tempData[i] = data[k];
      //      if (data[k] >= 0.0)  
      //      cout << i << " k=" << k << " resampled data=" << tempData[i] << endl;

    }

  
    return tempData;
}


vector<float> resampledData1(vector<float> &data)
{

    vector<float> tempData;
   
    long unsigned n = data.size();
    long unsigned n1 = (unsigned)(float(n) * 0.9);
    tempData.resize(n1);
    vector< bool > used;
    used.resize(n);  
   
    for(long unsigned i = 0; i < n; i++)
        used[i] = false;
    
    for(long unsigned i = 0; i < n1; i++)
    {
      long unsigned k = rand() % (n - 1);
      if (!used[k])
      { 
          tempData[i] = data[k];
          used[i] = true;
      }   
      //            cout << i << " resampled data=" << tempData[i] << endl;

    }
   
    return tempData;
}





/*****************************************************************
*
*****************************************************************/
float modeError(vector<float> &data, float &mode)
{

    unsigned long n = data.size() ;
    float logN = log10((float)n);
    long unsigned nSims = n * unsigned(logN * logN);
 
    nSims = max(n, nSims);
    nSims = min(nSims, (long unsigned)100);
 
    vector<float> simMode;


   
    for (long unsigned i = 0; i < nSims; i++)
    {
 

   
        vector<float> tempData = resampledData(data);
      
	//        for(unsigned j = 0; j < data.size(); j++)
	//	  cout << j << ") resampled data=" << tempData[j] << endl;

     
        float mean, median;
        float mode = halfRangeMode(tempData, mean, median);
        simMode.push_back(mode);
	//	cout << "Simulation " << i << " mode=" << simMode[i] << endl;
      

    }

    mode = Mean(simMode);  

    sort(simMode.begin(), simMode.end());

  
    // 95% confidence limit
    long unsigned il = (int)floor(0.05 * float(nSims)) - 1;
    il = max(il, (unsigned long)1);
    long unsigned iu = (unsigned)ceil(0.95 * float(nSims)) - 1;
    iu = min(iu, nSims - (long unsigned)2);
    cout << "nsims=" << nSims << " il=" << il << " iu=" << iu << endl;
    cout << "95% Confidence limit = " << simMode[il] << "-" << simMode[iu] << endl;

    double sum = 0.0;
    for (long unsigned i = 0; i < nSims; i++)
    {
      //      cout << "mode=" << mode << " sim=" << simMode[i] << endl;

        double diff = double(simMode[i] - mode); 
        sum += (diff * diff);

       
    }
  
    float error = 3.0 * sqrt(sum / double(nSims));

    sum = 0.0;
    long unsigned k = 0;
    for (long unsigned i = 0; i < nSims; i++)
    {
      
        if (fabs(simMode[i] - mode) <= error)
	{
            double diff = double(simMode[i] - mode); 
            sum += (diff * diff);
            k++;
        }
       
    }
   
    error = sqrt(sum / double(k));

    return error;



}





































