! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
module ommasterdefs_mod 

use dal
use sasdal
use param

type RowData
    real(double) :: ra
    real(double) :: dec

end type RowData




 


!*******************************************************************
! For null values
!*******************************************************************
integer, parameter :: int8NullValue = 127, int16NullValue = 32767, int32NullValue = -9999




!*****************************************************************
!
!
!*****************************************************************
integer, parameter :: maxNoColumnNames = 150

type newColumn
    character(20) :: name = "ABC"
    character(20) :: newname = "ABC"


    character(20) :: units = " "
    character(50) :: comment = " "
    
    integer       :: type = 0
    integer       ::  width = 0    
end type newColumn 


!******************************************************************
!
!
!******************************************************************



type ColumnArrayData


    type(columnT) :: columnH
 
    real(single), pointer :: real32ArrayData(:) => null()

    real(double), pointer :: real64ArrayData(:) => null()
    integer(int8), pointer :: integer8ArrayData(:) => null()
    integer(int16), pointer :: integer16ArrayData(:) => null()
    integer(int32), pointer :: integer32ArrayData(:) => null()
    integer :: type = 0
    character(20) ::  name = " "
    character(10) ::  units = " "
    character(50) ::  comment = " "
    real(single) ::   real32value;
    real(single) ::   real64value;
    integer(int8) ::  int8value = int8NullValue;
    integer(int16) :: int16value = int16NullValue;
    integer(int32) :: int32value = int32NullValue;
    character(100) :: stringvalue = ""

end type ColumnArrayData


!*****************************************************************
!
!
!*****************************************************************
type tableData

    type(tableT) :: tableh
    integer :: noRows
    integer :: noColumns = 0
    integer :: index(maxnoColumnNames) = 0
    integer(int8) :: dataType(maxnoColumnNames) = 0 
    logical :: columnExists(maxnoColumnNames) = .false.
    logical :: attributeExists(maxnoColumnNames) = .false.
   
   

    type(columnArrayData), dimension(maxnoColumnNames) :: columnData 
    
end type TableData

end module ommasterdefs_mod 
