// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#ifndef UTILITY_H
#define UTILITY_H
#include "utility.h"
#include "Dal.h"
#include <cstring>
#include <fstream>
#include <cmath>
#include "errstr.h"


const double degreesToRadians = M_PI / 180.0;
const double radiansToDegrees = 180.0 / M_PI;





const double radiansToArcSecs = (double)(180 * 3600) / M_PI;

class windowParameters
{

 public:

    int x0;
    int y0;
    int xBin;
    int yBin;
    windowParameters() : x0(0), y0(0), xBin(0), yBin(0) {}; 


};

bool getWindowParameters( string fileName, windowParameters &parameters);





bool isNull( float value);
bool isNull( double value);
bool isNull( int value);





/*******************************************************************
*
*******************************************************************/
double distance(double r1, double d1, double r2, double d2);




#endif













